﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DotP2013_Card_Builder
{
	class Ability
	{
		private bool m_bSimpleAbility;
		private bool m_bCommaSpace;
		private SortedList<string, string> m_colAbilityText;
		private String m_strStoredAbility;

		public Ability()
		{
			m_bSimpleAbility = false;
			m_bCommaSpace = false;
			m_colAbilityText = new SortedList<string, string>();
			m_strStoredAbility = null;
		}

		public Ability(string strAbility)
		{
			m_strStoredAbility = strAbility;
		}

		public string GetAbilityText(string strLang)
		{
			if (m_colAbilityText != null)
			{
				if (m_colAbilityText.IndexOfKey(strLang) > -1)
					return m_colAbilityText[strLang];
				else
					return m_colAbilityText["English"];
			}
			else
				return null;
		}

		public bool SimpleAbility
		{
			get
			{
				return m_bSimpleAbility;
			}
			set
			{
				m_bSimpleAbility = value;
			}
		}

		public bool CommaSpace
		{
			get
			{
				return m_bCommaSpace;
			}
			set
			{
				m_bCommaSpace = value;
			}
		}

		public SortedList<string, string> AbilityTextList
		{
			get
			{
				return m_colAbilityText;
			}
		}

		public string StoredAbilityCode
		{
			get
			{
				return m_strStoredAbility;
			}
			set
			{
				m_strStoredAbility = value;
			}
		}

		public virtual string GetCardAbilityCode()
		{
			throw new NotImplementedException();
		}

		public static bool TextRepresentsSimpleAbility(string strText)
		{
			bool bReturn = false;
			if (strText.StartsWith("Annihilator", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Battle Cry", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Changeling", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Deathtouch", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Defender", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Double strike", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Equip ", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Exalted", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Fear", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("First strike", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Flanking", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Flash", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Flying", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Forestwalk", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Haste", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Hexproof", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Infect", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Intimidate", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Islandwalk", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Lifelink", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Mountainwalk", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Plainswalk", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Reach", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Shadow", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Shroud", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Swampwalk", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Trample", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Unblockable", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Vigilance", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			else if (strText.StartsWith("Wither", StringComparison.OrdinalIgnoreCase))
				bReturn = true;
			return bReturn;
		}
	}
}
