﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DotP2013_Card_Builder
{
	class DotP2013CardType : CardType
	{
		public DotP2013CardType(string strType)
			: base(strType)
		{ }

		protected override SubType GetNewSubType(string strName, int nOrder)
		{
			return new DotP2013SubType(strName, nOrder);
		}

		public override string GetCardText()
		{
			string strReturn = "";
			string strPadding = Globals.Padding;
			foreach (string strSupertype in Supertypes)
				strReturn += strPadding + "<SUPERTYPE metaname=\"" + strSupertype + "\" />\r\n";
			foreach (string strCardType in CardTypes)
				strReturn += strPadding + "<TYPE metaname=\"" + strCardType + "\" />\r\n";
			foreach (SubType stSubType in SubTypes)
				strReturn += strPadding + stSubType.GetCardText(SubTypes.Count) + "\r\n";
			return strReturn;
		}
	}
}
