﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DotP2013_Card_Builder
{
	class DotP2013SubType : SubType
	{
		public DotP2013SubType()
			: base()
		{ }

		public DotP2013SubType(string strName)
			: base(strName)
		{ }

		public DotP2013SubType(string strName, int nOrder)
			: base(strName, nOrder)
		{ }

		public override string GetCardText(int nNumSubTypes)
		{
			int nMaxIndex = nNumSubTypes - 1;
			string strReturn = "<SUB_TYPE metaname=\"" + Name + "\" ";
			if (nNumSubTypes > 1)
			{
				strReturn += "order_en-US=\"" + Order.ToString() + "\" ";
				strReturn += "order_fr-FR=\"" + Order.ToString() + "\" ";
				// Spanish is reversed.
				strReturn += "order_es-ES=\"" + (nMaxIndex - Order).ToString() + "\" ";
				strReturn += "order_de-DE=\"" + Order.ToString() + "\" ";
				// Italian is reversed.
				strReturn += "order_it-IT=\"" + (nMaxIndex - Order).ToString() + "\" ";
				strReturn += "order_jp-JA=\"" + Order.ToString() + "\" ";
				strReturn += "order_ko-KR=\"" + Order.ToString() + "\" ";
				strReturn += "order_ru-RU=\"" + Order.ToString() + "\" ";
				strReturn += "order_pt-BR=\"" + Order.ToString() + "\" ";
			}
			strReturn += "/>";
			return strReturn;
		}

		public override int CompareTo(object obj)
		{
			SubType stOther = obj as SubType;
			if (stOther != null)
				return Order.CompareTo(stOther.Order);
			else
				return 0;
		}
	}
}
