﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace DotP2013_Card_Builder
{
	class DotP2013Templates
	{
		private static string m_strTemplateFile = "templates2013.xml";
		private static XmlDocument m_xmlTemplates;
		private static SortedList<string, string> m_colAbilityTemplates;

		public static string GetAbilityTemplate(string strAbility)
		{
			strAbility = strAbility.ToLower();
			if (m_colAbilityTemplates != null)
			{
				string strReturn = null;
				string strFoundKey = null;
				foreach (string strKey in m_colAbilityTemplates.Keys)
				{
					if (strAbility.StartsWith(strKey, StringComparison.OrdinalIgnoreCase))
					{
						if (strFoundKey != null)
						{
							// We prefer better matches (solves issues with looking up "Protection from X")
							if (strKey.Length > strFoundKey.Length)
								strFoundKey = strKey;
						}
						else
							strFoundKey = strKey;
					}
				}
				if (strFoundKey != null)
					strReturn = m_colAbilityTemplates[strFoundKey];
				return strReturn;
			}
			else
				return null;
		}

		public static bool LoadTemplates()
		{
			m_xmlTemplates = new XmlDocument();
			/*try
			{//*/
				m_xmlTemplates.Load(m_strTemplateFile);
				return ParseTemplates(m_xmlTemplates);
			/*}
			catch (Exception)
			{
				return false;
			}//*/
		}

		protected static bool ParseTemplates(XmlDocument xmlTemplates)
		{
			m_colAbilityTemplates = new SortedList<string, string>();
			XmlNodeList xnlAbilities = xmlTemplates.GetElementsByTagName("Ability");
			foreach (XmlNode xnAbility in xnlAbilities)
			{
				string strName = xnAbility.Attributes["Name"].InnerText;
				string strTemplate = Utils.ConstructStringFromInnerXml(xnAbility, Globals.Padding);
				m_colAbilityTemplates.Add(strName.ToLower(), strTemplate);
			}
			return true;
		}
	}
}
