﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Xml.Linq;
using System.Xml;

namespace DotP2013_Card_Builder
{
	class Utils
	{
		public static string ConvertTextNameToSymbol(string strName)
		{
			string strReturn = "";
			// Trim just in case.
			strName = strName.Trim();
			if (strName.Equals("Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{B}";
			else if (strName.Equals("Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{U}";
			else if (strName.Equals("Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{G}";
			else if (strName.Equals("Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{R}";
			else if (strName.Equals("White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{W}";
			else if ((strName.Equals("X", StringComparison.OrdinalIgnoreCase)) ||
				(strName.Equals("Variable Colorless", StringComparison.OrdinalIgnoreCase)))
				strReturn = "{X}";
			else if (strName.Equals("Tap", StringComparison.OrdinalIgnoreCase))
				strReturn = "{T}";
			else if (strName.Equals("Untap", StringComparison.OrdinalIgnoreCase))
				strReturn = "{q}";
			else if (strName.Equals("Black or Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{a}";
			else if (strName.Equals("Black or Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{b}";
			else if (strName.Equals("Blue or Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{g}";
			else if (strName.Equals("Blue or Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{h}";
			else if (strName.Equals("Green or Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{c}";
			else if (strName.Equals("Green or White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{d}";
			else if (strName.Equals("Red or Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{e}";
			else if (strName.Equals("Red or White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{f}";
			else if (strName.Equals("White or Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{i}";
			else if (strName.Equals("White or Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{j}";
			else if (strName.Equals("Phyrexian Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{J}";
			else if (strName.Equals("Phyrexian Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{K}";
			else if (strName.Equals("Phyrexian Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{L}";
			else if (strName.Equals("Phyrexian Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{I}";
			else if (strName.Equals("Phyrexian White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{O}";
			else if (strName.Equals("[Chaos]", StringComparison.OrdinalIgnoreCase))
				strReturn = "{Q}";
			else
			{
				// Attempt to convert to a number
				int nNum = -1;
				try
				{
					nNum = Int32.Parse(strName);
				}
				catch (Exception) { }
				if (nNum > -1)
					strReturn = "{" + nNum.ToString() + "}";
			}
			return strReturn;
		}

		public static string ConvertManaNameToSymbol(string strName)
		{
			string strReturn = "";
			// Trim just in case.
			strName = strName.Trim();
			if (strName.Equals("Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{B}";
			else if (strName.Equals("Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{U}";
			else if (strName.Equals("Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{G}";
			else if (strName.Equals("Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{R}";
			else if (strName.Equals("White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{W}";
			else if ((strName.Equals("X", StringComparison.OrdinalIgnoreCase)) ||
				(strName.Equals("Variable Colorless", StringComparison.OrdinalIgnoreCase)))
				strReturn = "{X}";
			else if (strName.Equals("Black or Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{B/G}";
			else if (strName.Equals("Black or Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{B/R}";
			else if (strName.Equals("Blue or Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{U/B}";
			else if (strName.Equals("Blue or Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{U/R}";
			else if (strName.Equals("Green or Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{G/U}";
			else if (strName.Equals("Green or White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{G/W}";
			else if (strName.Equals("Red or Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{R/G}";
			else if (strName.Equals("Red or White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{R/W}";
			else if (strName.Equals("White or Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{W/B}";
			else if (strName.Equals("White or Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{W/U}";
			else if (strName.Equals("Phyrexian Black", StringComparison.OrdinalIgnoreCase))
				strReturn = "{B/P}";
			else if (strName.Equals("Phyrexian Blue", StringComparison.OrdinalIgnoreCase))
				strReturn = "{U/P}";
			else if (strName.Equals("Phyrexian Green", StringComparison.OrdinalIgnoreCase))
				strReturn = "{G/P}";
			else if (strName.Equals("Phyrexian Red", StringComparison.OrdinalIgnoreCase))
				strReturn = "{R/P}";
			else if (strName.Equals("Phyrexian White", StringComparison.OrdinalIgnoreCase))
				strReturn = "{W/P}";
			else
			{
				// Attempt to convert to a number
				int nNum = -1;
				try
				{
					nNum = Int32.Parse(strName);
				}
				catch (Exception) { }
				if (nNum > -1)
					strReturn = "{" + nNum.ToString() + "}";
			}
			return strReturn;
		}

		public static string ConvertLanguageToLangCode(string strLang)
		{
			string strReturn = "";
			if (strLang.Equals("English", StringComparison.OrdinalIgnoreCase))
				strReturn = "en-US";
			else if (strLang.Equals("French", StringComparison.OrdinalIgnoreCase))
				strReturn = "fr-FR";
			else if (strLang.Equals("Spanish", StringComparison.OrdinalIgnoreCase))
				strReturn = "es-ES";
			else if (strLang.Equals("German", StringComparison.OrdinalIgnoreCase))
				strReturn = "de-DE";
			else if (strLang.Equals("Italian", StringComparison.OrdinalIgnoreCase))
				strReturn = "it-IT";
			else if (strLang.Equals("Japanese", StringComparison.OrdinalIgnoreCase))
				strReturn = "jp-JA";
			else if (strLang.Equals("Korean", StringComparison.OrdinalIgnoreCase))
				strReturn = "ko-KR";
			else if (strLang.Equals("Russian", StringComparison.OrdinalIgnoreCase))
				strReturn = "ru-RU";
			else if (strLang.Equals("Portuguese", StringComparison.OrdinalIgnoreCase))
				strReturn = "pt-BR";
			return strReturn;
		}

		public static XElement FindXElementWithAttributeValue(XContainer xcSection, string strAttribute, string strValue)
		{
			XElement xeLocated = null;
			foreach (XElement xe in xcSection.Elements())
			{
				if (xe.HasAttributes)
				{
					XAttribute xa = xe.Attribute(strAttribute);
					if (xa != null)
					{
						if (xa.Value.Equals(strValue, StringComparison.OrdinalIgnoreCase))
						{
							xeLocated = xe;
							break;
						}
					}
				}
				XElement xeLocatedBelow = FindXElementWithAttributeValue(xe, strAttribute, strValue);
				if (xeLocatedBelow != null)
				{
					xeLocated = xeLocatedBelow;
					break;
				}
			}
			return xeLocated;
		}

		public static XElement FindXElementWithClass(XContainer xcSection, string strClass)
		{
			return FindXElementWithAttributeValue(xcSection, "class", strClass);
		}

		public static XElement FindXElementWithId(XContainer xcSection, string strId)
		{
			return FindXElementWithAttributeValue(xcSection, "id", strId);
		}

		public static SortedList<string, int> GetMultiverseSetIds(XElement xeSets)
		{
			SortedList<string, int> colIds = new SortedList<string, int>();
			if (xeSets != null)
			{
				if (xeSets.HasElements)
				{
					foreach (XElement xe in xeSets.Elements())
					{
						int nMultiverseId = 0;
						string strSet = "";
						XAttribute xa = xe.Attribute("href");
						if (xa != null)
						{
							String strLink = xa.Value;
							nMultiverseId = Int32.Parse(strLink.Substring(strLink.IndexOf("multiverseid=") + 13));
						}
						XElement xeImg = xe.Element("{" + xe.Name.NamespaceName + "}" + "img");
						if (xeImg != null)
						{
							XAttribute xaTitle = xeImg.Attribute("title");
							if (xaTitle != null)
								strSet = xaTitle.Value;
						}
						if ((nMultiverseId != 0) && (strSet.Length > 0))
							colIds.Add(strSet, nMultiverseId);
					}
				}
			}
			return colIds;
		}

		public static SortedList<string, KeyValuePair<string, int>> GetCardLanguages(int nMultiverseId)
		{
			SortedList<string, KeyValuePair<string, int>> colLangs = new SortedList<string, KeyValuePair<string, int>>();
			XDocument xdLangs = XDocument.Parse(GetGathererLanguagesPage(nMultiverseId));
			ParseLanguageList(colLangs, xdLangs);
			if (colLangs.IndexOfKey("English") < 0)
			{
				// Need to add this multiverseId as English.
				string strEnglishName = null;
				int nEnglishId = 0;
				XElement xeEnglishName = FindXElementWithId(xdLangs, "ctl00_ctl00_ctl00_MainContent_SubContent_SubContentHeader_subtitleDisplay");
				if (xeEnglishName != null)
					strEnglishName = xeEnglishName.Value.Trim();
				XElement xeEnglishLink = FindXElementWithId(xdLangs, "ctl00_ctl00_ctl00_MainContent_SubContent_SubContentAnchors_DetailsAnchors_DetailsLink");
				if (xeEnglishLink != null)
				{
					XAttribute xaHref = xeEnglishLink.Attribute("href");
					if (xaHref != null)
					{
						int nIndex = xaHref.Value.IndexOf("multiverseid=", StringComparison.OrdinalIgnoreCase) + 13;
						nEnglishId = Int32.Parse(xaHref.Value.Substring(nIndex));
					}
				}
				if (nEnglishId > 0)
					colLangs.Add("English", new KeyValuePair<string, int>(strEnglishName, nEnglishId));
			}
			else
			{
				// Oops we have a language other than English as the one provided so we need to get a
				//	second language page so we know make sure we get all the right ids.
				int nSecondId = colLangs["English"].Value;
				XDocument xdSecond = XDocument.Parse(GetGathererLanguagesPage(nSecondId));
				ParseLanguageList(colLangs, xdSecond);
			}
			return colLangs;
		}

		private static void ParseLanguageList(SortedList<string, KeyValuePair<string, int>> colLangs, XContainer xcPage)
		{
			XElement xeTable = FindXElementWithClass(xcPage, "cardList");
			if (xeTable != null)
			{
				// We now have the available language table so now we need to check to make
				//	sure we actually have some other languages available.
				XElement xeNotFound = FindXElementWithId(xeTable, "ctl00_ctl00_ctl00_MainContent_SubContent_SubContent_languageList_noOtherLanguagesParent");
				if (xeNotFound == null)
				{
					// We have some available languages to get.
					foreach (XElement xeRow in xeTable.Elements())
					{
						XAttribute xaRowClass = xeRow.Attribute("class");
						if (xaRowClass != null)
						{
							if (!xaRowClass.Value.Equals("headerRow", StringComparison.OrdinalIgnoreCase))
							{
								XElement xeLink = null;
								XElement xeLang = null;
								// In each row we have 3 data elements
								//	1. Link with name and id
								//	2. Language (in English)
								//	3. Language (localised)
								foreach (XElement xeData in xeRow.Elements())
								{
									if (xeLink == null)
									{
										// First data item (unfortunately we need to go one level deeper due to the link)
										foreach (XElement xe in xeData.Elements())
										{
											// Should only ever be one element here, but we'll break out to be safe.
											xeLink = xe;
											break;
										}
									}
									else if (xeLang == null)
									{
										// Second data item
										xeLang = xeData;
									}
								}

								// Now we should have both of our required elements.
								string strLang = xeLang.Value.Trim();
								string strName = xeLink.Value.Trim();
								int nId = 0;
								XAttribute xa = xeLink.Attribute("href");
								if (xa != null)
								{
									int nIndex = xa.Value.IndexOf("multiverseid=", StringComparison.OrdinalIgnoreCase) + 13;
									nId = Int32.Parse(xa.Value.Substring(nIndex));
								}
								if (nId != 0)
								{
									// Clean-up on name for Portugese
									strLang = strLang.Replace(" (Brazil)", "");
									if (colLangs.IndexOfKey(strLang) < 0)
										colLangs.Add(strLang, new KeyValuePair<string, int>(strName, nId));
								}
							}
						}
					}
				}
			}
		}

		public static string ParseTextElement(XElement xeText)
		{
			string strReturn = "";
			foreach (XNode xnText in xeText.Nodes())
			{
				if (xnText.NodeType == XmlNodeType.Element)
				{
					// This cast should never fail since we asked the type above.
					XElement xeChild = xnText as XElement;
					if (xeChild != null)
					{
						if (xeChild.HasElements)
							strReturn += ParseTextElement(xeChild);
						else
						{
							if (xnText.ToString().IndexOf("<img ", StringComparison.OrdinalIgnoreCase) > -1)
							{
								// Need to pull out the alt tag so we know what symbol to replace this with.
								int nIndex = xnText.ToString().IndexOf("alt=\"", StringComparison.OrdinalIgnoreCase) + 5;
								int nEndIndex = xnText.ToString().IndexOf("\"", nIndex, StringComparison.OrdinalIgnoreCase);
								int nLength = nEndIndex - nIndex;
								strReturn += Utils.ConvertTextNameToSymbol(xnText.ToString().Substring(nIndex, nLength));
							}
							else if ((xnText.ToString().IndexOf("<i>", StringComparison.OrdinalIgnoreCase) > -1) || (xnText.ToString().IndexOf("</i>", StringComparison.OrdinalIgnoreCase) > -1))
							{
								if (xeChild.Value.Trim().Length < 1)
									strReturn += "|";
								else
									strReturn += "|" + xeChild.Value + "|";
							}
						}
					}
				}
				else
					strReturn += xnText.ToString();
			}
			return strReturn;
		}

		public static String GetGathererLanguagesPage(int nMultiverseId)
		{
			return CleanUpWebPage(GetWebPage("http://gatherer.wizards.com/Pages/Card/Languages.aspx?multiverseid=" + nMultiverseId));
		}

		public static String GetGathererOracleCardPage(int nMultiverseId)
		{
			return CleanUpWebPage(GetWebPage("http://gatherer.wizards.com/Pages/Card/Details.aspx?multiverseid=" + nMultiverseId));
		}

		public static String GetGathererPrintedCardPage(int nMultiverseId)
		{
			return CleanUpWebPage(GetWebPage("http://gatherer.wizards.com/Pages/Card/Details.aspx?printed=true&multiverseid=" + nMultiverseId));
		}

		public static String GetGathererSearchPage(string strSearch, bool bStartsWith = true)
		{
			if (bStartsWith)
				return CleanUpWebPage(GetWebPage("http://gatherer.wizards.com/Pages/Search/Default.aspx?name=[" + strSearch + "]"));
			else
				return CleanUpWebPage(GetWebPage("http://gatherer.wizards.com/Pages/Search/Default.aspx?name=+[" + strSearch + "]"));
		}

		public static string PrepareXmlString(string strText)
		{
			// This is in case I need to add clean-up code to change certain characters to html/xml friendly code.
			strText = strText.Replace(" & ", " &amp; ");
			return strText;
		}

		public static String GetWebPage(string strUrl)
		{
			String strSource = "";
			HttpWebRequest wbrq = (HttpWebRequest)WebRequest.Create(strUrl);
			wbrq.Method = "GET";
			HttpWebResponse wbrs = (HttpWebResponse)wbrq.GetResponse();
			StreamReader sr = new StreamReader(wbrs.GetResponseStream());
			strSource = sr.ReadToEnd();
			sr.Close();
			return strSource;
		}

		private static String CleanUpWebPage(String strSource)
		{
			// Gatherer does some things to their web-pages that is most-definitely not compliant with LinQ
			//	and will hang the microsoft XML parser.  So this function at least makes it to where I can
			//	parse the document with XDocument even if XmlDocument still hangs.
			// Some of the crap is missing white space, malformed tags, and missing special character
			//	transformations, now most browsers can cope with this without problem, but I imagine they
			//	have special code in their parsers to cope with crap like that.
			// Symbol codes to the actual symbols (XDocument doesn't like these codes, but has no problems with the symbols)
			strSource = strSource.Replace("&nbsp;", " ");
			strSource = strSource.Replace("&copy;", "©");
			// Fix mangled italicize tags
			strSource = strSource.Replace("<div class='cardtextbox'></i>", "<div class='cardtextbox'><i>");
			// Correct mangled links.
			while (strSource.IndexOf("href='", StringComparison.OrdinalIgnoreCase) > -1)
			{
				int nIndex = strSource.IndexOf("href='", StringComparison.OrdinalIgnoreCase) + 5;
				strSource = strSource.Remove(nIndex, 1);
				strSource = strSource.Insert(nIndex, "\"");
				int nAmp = strSource.IndexOf("&", nIndex) + 1;
				int nEnd = strSource.IndexOf("'", nIndex);
				while (nAmp < nEnd)
				{
					strSource = strSource.Insert(nAmp, "amp;");
					nAmp = strSource.IndexOf("&", nAmp) + 1;
					nEnd = strSource.IndexOf("'", nIndex);
				}
				strSource = strSource.Remove(nEnd, 1);
				strSource = strSource.Insert(nEnd, "\"");
			}
			// Add necessary whitespace
			strSource = strSource.Replace("\"class", "\" class");
			// Fix single ampersands by changing to "&amp;"
			strSource = strSource.Replace(" & ", " &amp; ");
			strSource = strSource.Replace("&name=", "&amp;name=");
			strSource = strSource.Replace("&special=", "&amp;special=");
			// Fix mangled foreign quotation marks
			strSource = strSource.Replace("<< ", "« ");
			// Fix screwed up flavour text linefeeds
			strSource = strSource.Replace("&#09", "</i></div><div><i>");	// Character 09 is supposed to be Horizontal Tab, but they used it for a line feed (at least on Plague Beetle).

			// Clean up for some mis-entered symbols (generally Unglued/Unhinged cards)
			strSource = strSource.Replace("ocT", "{T}");
			strSource = strSource.Replace("o1", "{1}");
			strSource = strSource.Replace("o2", "{2}");
			strSource = strSource.Replace("o4", "{4}");
			strSource = strSource.Replace("o7", "{7}");
			strSource = strSource.Replace("oB", "{B}");
			strSource = strSource.Replace("oG", "{G}");
			strSource = strSource.Replace("oR", "{R}");
			strSource = strSource.Replace("oU", "{U}");
			strSource = strSource.Replace("oW", "{W}");
			strSource = strSource.Replace("oX", "{X}");

			// Specific page mangle fixes
			strSource = strSource.Replace("<i>(Du kannst diese Karte verdeckt für o3 als eine 2/2 Kreatur spielen.</div><div class=\"cardtextbox\"> Decke sie zu einem beliebigen Zeitpunkt für ihre Morph-Kosten auf.)</i>", "<i>(Du kannst diese Karte verdeckt für o3 als eine 2/2 Kreatur spielen.</i></div><div class=\"cardtextbox\"><i> Decke sie zu einem beliebigen Zeitpunkt für ihre Morph-Kosten auf.)</i>");  // Riptide Biologist - German
			return strSource;
		}

		public static string GetPrettyQuotes(string strText)
		{
			if (strText.IndexOf('"') > -1)
			{
				int nStart = strText.IndexOf('"');
				int nEnd = strText.IndexOf('"', nStart + 1);
				while ((nStart > -1) && (nEnd > -1))
				{
					strText = strText.Remove(nStart, 1);
					strText = strText.Insert(nStart, "“");
					strText = strText.Remove(nEnd, 1);
					strText = strText.Insert(nEnd, "”");
					nStart = strText.IndexOf('"');
					nEnd = strText.IndexOf('"', nStart + 1);
				}
			}
			return strText;
		}

		public static string GetStringLine(string strMultiline, int nLineNum)
		{
			int nLine = 1;
			int nIndex = 0;		// Almost always the start of a line.
			while (nIndex < strMultiline.Length)
			{
				nIndex = strMultiline.IndexOf("\r\n", nIndex, StringComparison.OrdinalIgnoreCase) + 2;
				if (nIndex > 1)
				{
					nLine++;
					if (nLine == nLineNum)
						break;
				}
			}
			int nEndIndex = strMultiline.IndexOf("\r\n", nIndex, StringComparison.OrdinalIgnoreCase);
			return strMultiline.Substring(nIndex, nEndIndex - nIndex);
		}

		public static string PaddingForLevel(string strPadding, int nLevel)
		{
			string strReturn = "";
			for (int i=0; i < nLevel; i++)
				strReturn +=strPadding;
			return strReturn;
		}

		public static string ConstructStringFromInnerXml(XmlNode xnNode, string strPadding, int nStartLevel = 1)
		{
			int nCurrentLevel = nStartLevel;
			string strReturn = "";
			foreach (XmlNode xnChild in xnNode.ChildNodes)
				strReturn += RecursiveConstructStringFromInnerXml(xnChild, strPadding, nStartLevel);
			return strReturn;
		}

		private static string RecursiveConstructStringFromInnerXml(XmlNode xnNode, string strPadding, int nLevel)
		{
			string strReturn = "";
			if ((!xnNode.Name.Equals("#cdata-section", StringComparison.OrdinalIgnoreCase)) &&
				(!xnNode.Name.Equals("#text", StringComparison.OrdinalIgnoreCase)))
			{
				strReturn += PaddingForLevel(strPadding, nLevel) + "<" + xnNode.Name;
				if (xnNode.Attributes != null)
					foreach (XmlAttribute xaVar in xnNode.Attributes)
						strReturn += " " + xaVar.Name + "=\"" + xaVar.Value + "\"";

				if (xnNode.HasChildNodes)
				{
					strReturn += ">";
					if (!xnNode.Name.Equals("LOCALISED_TEXT", StringComparison.OrdinalIgnoreCase))
						strReturn += "\r\n";
					foreach (XmlNode xnChild in xnNode.ChildNodes)
						strReturn += RecursiveConstructStringFromInnerXml(xnChild, strPadding, nLevel + 1);
					if (!xnNode.Name.Equals("LOCALISED_TEXT", StringComparison.OrdinalIgnoreCase))
						strReturn += PaddingForLevel(strPadding, nLevel);
					strReturn += "</" + xnNode.Name + ">\r\n";
				}
				else if (xnNode.InnerText.Length > 0)
					strReturn += ">" + xnNode.InnerText + "</" + xnNode.Name + ">\r\n";
				else
					strReturn += " />\r\n";
			}
			else if (xnNode.Name.Equals("#cdata-section", StringComparison.OrdinalIgnoreCase))
				strReturn += "<![CDATA[" + xnNode.InnerText + "]]>";
			else if (xnNode.Name.Equals("#text", StringComparison.OrdinalIgnoreCase))
				strReturn += PaddingForLevel(strPadding, nLevel) + xnNode.InnerText.Trim() + "\r\n";
			return strReturn;
		}
	}
}
