﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace DotP2013_Card_Builder
{
	public partial class frmMain : Form
	{
		private CardInfo m_ciCard;

		public frmMain()
		{
			InitializeComponent();
			Globals.LoadSettings();
			DotP2013Templates.LoadTemplates();
		}

		private void cmdGatherInfo_Click(object sender, EventArgs e)
		{
			m_ciCard = new DotP2013CardInfo();
			if (m_ciCard.GetInformation(Int32.Parse(txtMultiverseId.Text)))
			{
				string strCardCode = m_ciCard.GetCardCode();
				txtOutput.Text = strCardCode;
				// Get Filename from card code.
				XmlDocument xdCard = new XmlDocument();
				xdCard.LoadXml(strCardCode);
				XmlNode xnFilename = xdCard.GetElementsByTagName("FILENAME")[0];
				// Save to file (in UTF-8 with BOM)
				using (FileStream fs = new FileStream(xnFilename.Attributes["text"].Value + ".XML", FileMode.Create, FileAccess.Write, FileShare.None))
				{
					StreamWriter sw = new StreamWriter(fs, new UTF8Encoding(Globals.IncludeBOM));
					sw.Write(strCardCode);
					sw.Close();
				}
			}
		}

		private void txtMultiverseId_KeyPress(object sender, KeyPressEventArgs e)
		{
			if ((e.KeyChar == 0x0a) || (e.KeyChar == 0x0d))
			{
				e.Handled = true;
				cmdGatherInfo_Click(null, null);
			}
		}
	}
}
